<?php
/*
 *************************************************************************
 *  (c) Copyright IBM Corporation. 2008, 2009.  All Rights Reserved
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 **************************************************************************
 */

class menumgr {

	public $idsadmin;

	function __construct(&$idsadmin)
	{
		$this->idsadmin = $idsadmin;
		$this->idsadmin->html->set_pagetitle( $this->idsadmin->lang('menumgr') );
		$this->idsadmin->load_template("template_menumgr");
	}

	function run()
	{
		switch ( $this->idsadmin->in['run'] )
		{
			case "getXMLMenu":
				$this->getXMLMenu();
				break;
			default:
				$this->def();
				break;
		}
	}

	function getXMLMenu()
	{
		if ( isset($_POST['dd'])  )
		{
			return $this->saveMenu();
		}
		require_once("../lib/menu.php");
		$m = new menu($this->idsadmin);

		$xml = $m->getmenufromdb(1);
		echo $xml;
		die();
	}

	function saveMenu()
	{
		//error_log( var_export($_POST['dd'],true) );
		
		$xml = stripslashes( "<menus>{$_POST['dd']}</menus>" );
		require_once ROOT_PATH."/lib/connections.php";

		$cb = new connections($this->idsadmin);
		$conndb = $cb->db;

		$conndb->beginTransaction();
		
		$conndb->query("DELETE FROM oat_menu");
		
		$max_menu_pos = 1;

		$sxml = new SimpleXMLElement($xml);

		$insstr  = "insert into oat_menu (menu_pos,menu_name,lang,link,title,cond,parent,plugin_id,expanded,linkid) ";
		$insstr .= "values (:menu_pos,:menu_name,:lang,:link,:title,:cond,:parent,:plugin_id,:expanded , :linkid ); ";
			
		$insStmt = $conndb->prepare($insstr);

		foreach ($sxml->menu as $m)
		{
			$menu_pos = $max_menu_pos;
			//lets deal with the toplevel 'menu' first ..
			$parent = 0;
			$menu_name = (string)$m->attributes()->lang;
            
			$insStmt->bindValue(":menu_pos"    , $menu_pos);
			$insStmt->bindValue(":menu_name"   , htmlentities( (string)$m->attributes()->name ) );
			$insStmt->bindValue(":lang"        , (string)$m->attributes()->lang);
			$insStmt->bindValue(":link"        , htmlentities( (string)$m->attributes()->link ) );
			$insStmt->bindValue(":title"       , htmlentities( (string)$m->attributes()->title ) );
			$insStmt->bindValue(":cond"        , htmlentities( (string)$m->attributes()->cond) );
			$insStmt->bindValue(":parent"      , $parent);
			$insStmt->bindValue(":plugin_id"   , (string)$m->attributes()->plugin_id);
			$insStmt->bindValue(":expanded"    , (string)$m->attributes()->expand);
			$insStmt->bindValue(":linkid"      , (string)$m->attributes()->linkid);

			$insStmt->execute();


			$last_id_stmt = $conndb->query("SELECT last_insert_rowid() as last_id");
			$last_id = $last_id_stmt->fetch();
			$last_id_stmt->closeCursor();

			//now lets move onto the items for this menu.
			$parent = $last_id['LAST_ID'];

			$menu_item_pos = 1;
			foreach ( $m  as $items )
			{
				$menu_name = (string)$items->attributes()->name;

				$insStmt->bindValue( ":menu_pos"     , $menu_pos );
				$insStmt->bindValue( ":menu_name"    , htmlentities( (string)$items->attributes()->name ) );
				$insStmt->bindValue( ":lang"         , (string)$items->attributes()->lang);
				$insStmt->bindValue( ":link"         , htmlentities( (string)$items->attributes()->link ) );
				$insStmt->bindValue( ":title"        , htmlentities( (string)$items->attributes()->title ) );
				$insStmt->bindValue( ":cond"         , htmlentities( (string)$items->attributes()->cond ) );
				$insStmt->bindValue( ":parent"       , $parent );
				$insStmt->bindValue( ":plugin_id"    , (string)$items->attributes()->plugin_id );
				$insStmt->bindValue( ":expanded"     , (string)$items->attributes()->expand );
				$insStmt->bindValue( ":linkid"       , (string)$items->attributes()->linkid );

				$insStmt->execute();
				$menu_item_pos++;
			}
			$max_menu_pos++;
		}
		$conndb->commit();
		die( "0" );
	}

	function def()
	{
		$this->idsadmin->html->add_to_output( $this->idsadmin->template['template_menumgr']->renderMenuManager($this->idsadmin->phpsession->get_lang()) );
	}
}
?>