<?php
/*
 **************************************************************************
 *  (c) Copyright IBM Corporation. 2007.  All Rights Reserved
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 **************************************************************************
 */


/**
 * This is a class which shows basic functionality,
 * much of the advanced show functionality has been
 * moved to onstat.php
 *
 */
class show {

    public $idsadmin;
/**
 * The constructor for the class,
 * Make sure the current language is set
 * and a default title for the page.
 *
 * @return show
 */
    function __construct(&$idsadmin)
    {
        $this->idsadmin = &$idsadmin;
        $this->idsadmin->load_template("template_login");
        $this->idsadmin->load_lang("show");
        $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('Show'));
    }


/**
 * The run function is what index.php will call.
 * The decission of what to actually do is based
 * on the value of the $this->idsadmin->in['do']
 *
 */
    function run()
    {


        switch($this->idsadmin->in['do'])
        {
            case 'showCommands';
                $this->idsadmin->setCurrMenuItem("admincommands");
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('CmdHistory'));
                $this->showCommands();
                break;
            case 'showOnlinelog';
                $this->idsadmin->setCurrMenuItem("onlinelog");
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('OnlineMsgLog'));
                $this->showOnlinelog();
                break;
            case 'showOnlineLogTail';
                $this->idsadmin->setCurrMenuItem("onlinelog");
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('OnlineMsgLog'));
                $this->showOnlineLogTail();
                break;
            case 'showBarActLogTail';
                $this->idsadmin->setCurrMenuItem("baractlog");
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('OnBarActLog'));
                $this->showBarActLogTail();
                break;
            case 'showOnconfig';
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('onconfig'));
                $this->showOnconfig();
            break;
            case 'showChunks';
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('chunks'));
                $this->showChunks();
            break;
            case 'showCommands';
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('commands'));
                $this->showCommands();
            break;
            case 'showDatabases';
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('Databases'));
                $this->showDatabases();
            break;
            case 'showAlerts';
                $this->idsadmin->html->set_pagetitle($this->idsadmin->lang('Alerts'));
                $this->showAlerts();
            break;
            default:
                $this->idsadmin->error($this->idsadmin->lang('sorry'));
                break;
        }
        return;
    } # end function run

    # this is what gets called by default.
/**
    * Display the Tail of the server log file
    * (i.e. the online log file).
    *
 */
 function showOnlineLogTail()
 {

     require_once ROOT_PATH."lib/gentab.php";

     $tab = new gentab($this->idsadmin);
     $tab->display_tab($this->idsadmin->lang("OnlineMsgLog"),
     array(
                  "1" => $this->idsadmin->lang('Messages'),
                  ),
             "select skip 1 trim(line) as line from sysonlinelog where offset > -10000",
             "gentab_show_onlinelog.php" );

 } #end default


/**
 * Display in a table the end of the
 * BAR activity log.
 *
 */
 function showBarActLogTail()
 {

     require_once ROOT_PATH."lib/gentab.php";

     $tab = new gentab($this->idsadmin);
     $tab->display_tab($this->idsadmin->lang('OnBarActLog'),
     array(
                  "1" => $this->idsadmin->lang('Messages'),
                  ),
             "select skip 1 line from sysbaract_log where offset > -10000",
             "gentab_show_baractlog.php" );

 } #end default

    /**
     * This will show the entire online log.
     * The log file can be large that is why we
     * have a version to show the tail of the log
     * file so DBA can see the most recent work without
     * have to go through the entire file.
     *
     */
    function showOnlinelog()
    {

        require_once ROOT_PATH."lib/gentab.php";
        $cols = array(
                  "Message" => "Message",
                  );
                  $tab = new gentab($this->idsadmin);
                  $tab->display_tab_pag($this->idsadmin->lang("OnlineMsgLog"),
                  $cols,
             "select line from sysonlinelog " ,20);

    } #end showOnlinelog

/**
 * This function show the databas server configuration
 * file in tabular format.
 *
 */
    function showOnconfig()
    {
        require_once ROOT_PATH."lib/gentab.php";


        $tab = new gentab(&$this->idsadmin);
        $tab->display_tab_pag($this->idsadmin->lang('onconfigfile'),
        array(
                  "1" => $this->idsadmin->lang('Name'),
                  "2" => $this->idsadmin->lang('CurrentValue'),
                  ),
             "select trim(cf_name) as name, " .
             " trim(cf_effective) as effective ".
             " from syscfgtab where cf_flags = 0 order by name",12);

    } #end showOnconfig

/**
 * Show is a table the chunks for both
 * primary devices and mirrored devices
 *
 */
    function showChunks()
    {

        require_once ROOT_PATH."lib/gentab.php";
        $tab = new gentab(&$this->idsadmin);
        $tab->display_tab( $this->idsadmin->lang('ChukInfo'),
        array(
                  "1" => $this->idsadmin->lang('ChunkNumber'),
                  "2" => $this->idsadmin->lang('ChunkPath'),
                  "3" => $this->idsadmin->lang('Size'),
                  "4" => $this->idsadmin->lang('Offset'),
                  "5" => $this->idsadmin->lang('Free'),
                  ),
             "select chknum, trim(fname), chksize, offset, nfree  " .
             " from syschktab " .
             " UNION " .
             "select chknum, trim(fname), chksize, offset, nfree  " .
             " from sysmchktab " .
             " order by 1");

    } # end showChunks

/**
 * This function show a list of all database in
 * the system.  This gives a very basic view of
 * what databases we have.
 *
 */
    function showDatabases()
    {
        require_once ROOT_PATH."lib/gentab.php";
        $tab = new gentab(&$this->idsadmin);
        $tab->display_tab_pag("Databases",
        array(
                  "1" => $this->idsadmin->lang('Name'),
                  "2" => $this->idsadmin->lang('CreateDate'),
                  ),
"select '<a href=index.php?act=demo&do=connectdb&dbname='||trim(name)||'>'||trim(name)||'</a>' as name,".

             " created ".
             " from sysdatabases order by name",4);

    } #end showDatabases

/**
 * Show in a table the admin commands which
 * have been executed.  This function must
 * get it own database handle to the sysadmin
 * database.
 *
 */
    function showCommands( )
    {

        require_once ROOT_PATH."lib/gentab.php";

        $dbadmin = $this->idsadmin->get_database("sysadmin");
        $tab = new gentab(&$this->idsadmin);
        $qry = "SELECT ".
              " trim(cmd_user)||' @ '|| cmd_hostname as user, " .
              " cmd_exec_time, " .
              " cmd_executed, " .
              " cmd_ret_msg " .
              " FROM command_history order by cmd_number desc";

              $qrycnt = "SELECT count( * ) as cnt from command_history ";

              $tab->display_tab_by_page($this->idsadmin->lang('CmdHistory'),
              array(
                  "1" => $this->idsadmin->lang('User'),
                  "2" => $this->idsadmin->lang('Time'),
                  "3" => $this->idsadmin->lang('CommandExecuted'),
                  "4" => $this->idsadmin->lang('ReturnMsg'),
                  ),
                  $qry, $qrycnt, 15, "template_gentab_order_html.php",
                  $dbadmin);

    }

} // end class
?>
