<?php
/*
 **************************************************************************   
 *  (c) Copyright IBM Corporation. 2007, 2009.  All Rights Reserved
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 **************************************************************************
 */


class template_login {
    public $idsadmin;

    function error($err_string="")
    {
        $HTML = "";
		if($err_string != "")
        	$HTML .= $this->idsadmin->template["template_global"]->global_error($err_string);
        return $HTML;
    }

    function showForm()
    {
	$this->idsadmin->load_lang("misc_template");
        $HTML = "";
        $HTML .= <<<EOF
<form name="login" action="index.php?act=login&amp;do=dologin" method="post">
   <table width="100%" border="0">
   <tr>
     <td>
     <input type='radio' class='radiobutton' name='login_admin' value='{$this->idsadmin->lang("Login")}' checked >{$this->idsadmin->lang('login')}
     <input type='radio' class='radiobutton' name='login_admin' value='{$this->idsadmin->lang("Admin")}' onClick='redirectToAdmin()'>{$this->idsadmin->lang('admin')}
     </td>
     <td>
     {$this->showHelpLinks()}
     </td>
   </tr>
   </table>
   

<table width="100%" border="0">
<tr>
   <td width="35%" valign="top" colspan="2">
   {$this->showQuickLoginForm()}
   </td>
   <td width="1%" valign="top" colspan="2">
   </td>
   <td width="50%" valign="top" colspan="2">
   {$this->showLoginForm()}
   </td>
</tr>
</table>

</form>
EOF;
return $HTML;
    }

    function showgroups($grps)
    {
        $HTML = "";
        $selected="";
        foreach ($grps as $k => $v )
        {
            if ($v['GROUP_NUM']==1)
            {
                $selected="SELECTED";
            } else {
                $selected="";
            }
            if ($v['GROUP_NAME']=="Default")
            {
                // Localize "Default" to the user's language
                $grpname = $this->idsadmin->lang("Default");
            } else {
                // If it's a user entered group name, display as is
                $grpname = $v['GROUP_NAME'];
            }

            $HTML .=  "<option {$selected} value='{$v['GROUP_NUM']}'>{$grpname}</option>";
        }
        return $HTML;
    }#end showgroups

    function showconns($conns)
    {

        $HTML = "";
        $HTML .=  "<option value='0' SELECTED>{$this->idsadmin->lang("selectaconnection")}</option>";
        foreach ($conns as $k => $v )
        {
            $HTML .=  "<option {$selected} value='{$v['CONN_NUM']}'>{$v['SERVER']}@{$v['HOST']}</option>";
        }
        return $HTML;
    } // end showconns

    function showQuickLoginForm()
    {
        $HTML = "";
        require_once ROOT_PATH."/lib/connections.php";
        $db = new connections($this->idsadmin);
        $stmt = $db->db->query("select * from groups");

        $grps = $stmt->fetchAll();

        $HTML .= <<<EOF
<script type ="text/javascript">

function resetLoginForm()
{
document.login.informixserver.value = '';
document.login.host.value = '';
document.login.port.value = '';
document.login.username.value = '';
document.login.userpass.value = '';
document.login.idsprotocol.value = 'onsoctcp';
}

function connectgroup()
{
  var group_num = 
    document.login.groups.options[document.login.groups.selectedIndex].value;
  var group_pass = document.login.grouppass.value;

  if (window.XMLHttpRequest) { 
     request = new XMLHttpRequest();
     if (request.overrideMimeType) {
        request.overrideMimeType('text/html');
     }
  } else if (window.ActiveXObject) { // IE
     try {
        request = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) {
        try {
           request = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {}
     }
  }
  request.open("POST", "index.php?act=login&do=connectgroup&group_num=" +
      group_num + "&group_pass=" + escape(group_pass));
  request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  request.onreadystatechange = function() {
    if (request.readyState == 4) {
       if (request.status == 200) {
          result = request.responseText;
          document.getElementById('connectionlist').innerHTML = result;
       }
       else {
          document.getElementById('connectionlist').innerHTML = "Error:"+request.status+" occurred";
       }
    }
  }
  request.send(null);
  return true;
}

// given a specific connection id, populate the server connection details
function populateconnection(con)
{
    var conn_num = 
    con.options[con.selectedIndex].value;

 var group_pass = document.login.grouppass.value;

  if (window.XMLHttpRequest) { 
     request = new XMLHttpRequest();
     if (request.overrideMimeType) {
        request.overrideMimeType('text/xml');
     }
  } else if (window.ActiveXObject) { // IE
     try {
        request = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (e) {
        try {
           request = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {}
     }
  }
  request.open("POST", "index.php?act=login&do=popserver&conn_num=" +
      conn_num+ "&group_pass=" + escape(group_pass));
  request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  request.onreadystatechange = function() {
    if (request.readyState == 4) {
       if (request.status == 200) {
         resetLoginForm();
         var xmlDoc = request.responseXML.documentElement;
         var conn =  xmlDoc.getElementsByTagName("connection");

         if ( xmlDoc.getElementsByTagName("server").item(0).firstChild == null ) 
		 {
		     return;
		 }
         
         document.login.informixserver.value = 
            xmlDoc.getElementsByTagName("server").item(0).firstChild.data;
         document.login.host.value = 
            xmlDoc.getElementsByTagName("host").item(0).firstChild.data;
         document.login.port.value = 
            xmlDoc.getElementsByTagName("port").item(0).firstChild.data;
         document.login.username.value = 
            xmlDoc.getElementsByTagName("username").item(0).firstChild.data;
         if (xmlDoc.getElementsByTagName("password").item(0).firstChild != null)
         {
            document.login.userpass.value = 
          	  xmlDoc.getElementsByTagName("password").item(0).firstChild.data;
         }
         if (xmlDoc.getElementsByTagName("idsprotocol").item(0).firstChild != null)
         {	
         	document.login.idsprotocol.value = 
            	xmlDoc.getElementsByTagName("idsprotocol").item(0).firstChild.data;
         }
         document.login.conn_num.value = 
            xmlDoc.getElementsByTagName("conn_num").item(0).firstChild.data;
       }
       else {
          document.getElementById('connectionlist').innerHTML = "Error:"+request.status+" occurred";
       }
    }
  }
  request.send(null);
  return true;
}

function getConns(what,idx)
{
	document.getElementById('connectionlist').innerHTML = '';
	document.login.grouppass.value='';
resetLoginForm();
}

function redirectToAdmin() 
{
window.location= "admin/index.php?act=admin";
return;
}

</script>

<fieldset>
<table class="login" cellspacing="0" cellpadding="0">
<tr>
<th class="formheader" colspan=3>{$this->idsadmin->lang('quicklogin')}</th>
</tr>
<tr>
    <td class="formleft">{$this->idsadmin->lang('group')}</td>
    <td colspan=2 class="formright">
        <select name="groups" onChange="getConns('groups',document.login.groups.selectedIndex)">
        {$this->showgroups($grps)}
        </select>
    </td>
</tr>
<tr>
   <td class="formleft">{$this->idsadmin->lang('password')}</td>
   <td class="formright">
       <input type="password" name="grouppass" value="{$this->idsadmin->phpsession->instance->get_passwd()}"/>
   </td>
   <td class="formright" align='center'>
      <input type="submit"
          onClick="connectgroup();return false;" class="button" 
          value="{$this->idsadmin->lang("getservers")}" />
     
   </td>
</tr>
<tr>
   <td class="formleft"></td>
   <td colspan=2 class="formleft">
   <div id="connectionlist"></div>
   </td>
</tr>
</table>
</fieldset>
EOF;
return $HTML;
    }

    function showLoginForm()
    {
        $protocol = $this->idsadmin->phpsession->instance->get_idsprotocol();
        switch ( $protocol )
        {
            case "onsoctcp":
                $onsocSELECTED="SELECTED";
                break;
            case "ontlitcp":
                $ontliSELECTED="SELECTED";
                break;
            case "onsocssl":
             	$onsslSELECTED="SELECTED";
              	break;
        }
        
        $HTML = "";
        $HTML .= <<<EOF

<script type='text/javascript'>
function doLogin()
{
	// First test if cookies are supported.  If yes, proceed with login.  
	// If not, we won't be able to login so give the user an error.
	document.cookie = "cookies=true";
	if (document.cookie)
	{
		document.login.submit();
    } else {
    	alert ("{$this->idsadmin->lang('cookies_required')}");
    }
}
</script>
<fieldset>
<table class="login" cellspacing="0" cellpadding="0">
<tr>
<th class="formheader" colspan=3>{$this->idsadmin->lang('serverdetails')}</th>
</tr>
<tr>
   <td class="formleft">{$this->idsadmin->lang("informixserver")}</td>
   <td class="formright">
      <input type="text" name="informixserver" value="{$this->idsadmin->phpsession->instance->get_servername()}"/>
   </td>
</tr>

<tr>
   <td class="formleft">{$this->idsadmin->lang('hostname')}</td>
   <td class="formright">
      <input type="text" name="host" value="{$this->idsadmin->phpsession->instance->get_host()}"/>
   </td>
</tr>

<tr>
   <td class="formleft">{$this->idsadmin->lang('port')}</td>
   <td class="formright">
      <input type="text" name="port" value="{$this->idsadmin->phpsession->instance->get_port()}"/>
   </td>
</tr>


<tr>
   <td class="formleft">{$this->idsadmin->lang('username')}</td>
   <td class="formright">
      <input type="text" name="username" value="{$this->idsadmin->phpsession->instance->get_username()}"/>
   </td>
</tr>
<tr>
   <td class="formleft">{$this->idsadmin->lang('password')}</td>
   <td class="formright">
       <input type="password" name="userpass" value="{$this->idsadmin->phpsession->instance->get_passwd()}"/>
   </td>
</tr>
<tr>
    <td class="formleft">{$this->idsadmin->lang("idsprotocol")}</td>
    <td class="formright">
        <select name="idsprotocol">
            <option value="onsoctcp" $onsocSELECTED>onsoctcp</option>
            <option value="ontlitcp" $ontliSELECTED>ontlitcp</option>
            <option value="onsocssl" $onsslSELECTED>onsocssl</option>
        </select>
    </td>
</tr>
<tr sytle="display:none">
   <td sytle="display:none"></td>
   <td sytle="display:none"><input type=hidden name="conn_num" value="{$this->idsadmin->phpsession->instance->get_conn_num()}" />
   </td>
</tr>
<tr>
   <td colspan="2" class="formsubtitle" align='center'>
      <input type="button" class="button" name="Submit" value="{$this->idsadmin->lang("login")}"  onClick="doLogin()"/>
   </td>
</tr>
</table>
</fieldset>

EOF;
        return $HTML;
    }
    
    function showHelpLinks()
    {
    	$HTML = <<<EOF
<script type="text/javascript">
function popAboutOAT()
{
	w = window.open( 'index.php?act=help&do=aboutOAT','About OAT','width=450,height=300,resizable=yes,scrollbars=yes');
        w.focus();
}
</script>
<div align="right">
&middot;
<a href="javascript:popAboutOAT()">{$this->idsadmin->lang('aboutOAT')}</a>
&middot;
<a href="javascript:showDocuments('README.html','readme'); "  title="{$this->idsadmin->lang('readme')}">{$this->idsadmin->lang('readme')}</a>
&middot;
<a href="javascript:showDocuments('HOWTO.html','HowDoI'); "  title="{$this->idsadmin->lang('HowDoI')}">{$this->idsadmin->lang('HowDoI')}</a>
&middot;
</div>
EOF;
		return $HTML;
    }

}

?>
